#ifndef MKSRC_HH
#define MKSRC_HH
/*
// ============================================================================
//
// = FILENAME
//     mksrc.hh
//
// = AUTHOR(S)
//     Graham Dumpleton
// 
// = COPYRIGHT
//     Copyright 1993 OTC LIMITED
//
// ============================================================================
*/

#include <OTC/text/string.hh>

/* ------------------------------------------------------------------------- */

class APP_ConfigItem
{
    friend istream&	operator>>(istream& ins, APP_ConfigItem& theItem);

  public:

			APP_ConfigItem()
				{}

			APP_ConfigItem(APP_ConfigItem const& theItem);

    APP_ConfigItem&	operator=(APP_ConfigItem const& theItem);

    static OTC_String const&	file()
				{ return myFile; }

    static void		setFile(OTC_String const& theFile)
				{ myFile = theFile; }

    OTC_String const&	project() const
				{ return myProject; }

    OTC_String const&	pattern() const
				{ return myPattern; }

    OTC_String const&	program() const
				{ return myProgram; }

    OTC_String const&	helpFile() const
				{ return myHelpFile; }

  private:

    static OTC_String	myFile;

    OTC_String		myProject;

    OTC_String		myPattern;

    OTC_String		myProgram;

    OTC_String		myHelpFile;
};


/* ------------------------------------------------------------------------- */

#endif /* MKSRC_HH */
