#ifndef OTC_OTC_H
#define OTC_OTC_H
/*
// ============================================================================
//
// = LIBRARY
//     OTC
//
// = FILENAME
//     OTC.h
//
// = AUTHOR(S)
//     Graham Dumpleton
// 
// = COPYRIGHT
//     Copyright 1991 1992 1993 OTC LIMITED
//     Copyright 1994 1995 DUMPLETON SOFTWARE CONSULTING PTY LIMITED
//
// ============================================================================
*/

/* ------------------------------------------------------------------------- */

/* Force this header into dependencies. */
extern int OTCLIB_HEADERDUMMY;

/* ------------------------------------------------------------------------- */

#include <OSE/OSE.h>

/* ------------------------------------------------------------------------- */

#ifdef __cplusplus
#if defined(__GNUG__) && defined(HAVE_RTTI)
#include <std/typeinfo.h>
#endif
#endif

/* ------------------------------------------------------------------------- */

#ifndef OTC_THREAD_THREAD_HH
#include <OTC/thread/thread.hh>
#endif
#ifndef OTC_OSTORE_OSTORE_HH
#include <OTC/ostore/ostore.hh>
#endif

/* ------------------------------------------------------------------------- */

#ifndef OTC_MISC_BOOL_H
#include <OTC/misc/bool.h>
#endif
#ifndef OTC_MISC_MACROS_H
#include <OTC/misc/macros.h>
#endif
#ifndef OTC_MISC_ASCII_H
#include <OTC/misc/ascii.h>
#endif
#ifndef OTC_MISC_TYPES_H
#include <OTC/misc/types.h>
#endif
#ifndef OTC_MISC_LIMITS_H
#include <OTC/misc/limits.h>
#endif

#ifndef OTC_DEBUG_ERRORS_H
#include <OTC/debug/errors.h>
#endif
#ifndef OTC_DEBUG_ASSERT_H
#include <OTC/debug/assert.h>
#endif
#ifndef OTC_DEBUG_ENSURE_H
#include <OTC/debug/ensure.h>
#endif
#ifndef OTC_DEBUG_WARNING_H
#include <OTC/debug/warning.h>
#endif

#ifdef __cplusplus
#ifndef OTC_ANSI_TERMNATE_HH
#include <OTC/ansi/termnate.hh>
#endif
#ifndef OTC_ANSI_TEMPLATE_HH
#include <OTC/ansi/template.hh>
#endif
#ifndef OTC_DEBUG_NEWHNDLR_HH
#include <OTC/debug/newhndlr.hh>
#endif
#ifndef OTC_DEBUG_TERMFUNC_HH
#include <OTC/debug/termfunc.hh>
#endif
#ifndef OTC_DEBUG_THROWERR_HH
#include <OTC/debug/throwerr.hh>
#endif
#ifndef OTC_OSTORE_TYPESPEC_HH
#include <OTC/ostore/typespec.hh>
#endif
#ifndef OTC_OSTORE_LOCALITY_HH
#include <OTC/ostore/locality.hh>
#endif
#endif

/* ------------------------------------------------------------------------- */

#ifdef __OSE_TEMPLATES__

// [01] OTC_BaseActions

// ObjectStore ONLY

// OSE_MARK_COMPILED OTC_BaseActions<int>;
// OSE_MARK_COMPILED OTC_BaseActions<OTC_String>;

// [02] OTC_Bucket

OSE_MARK_COMPILED OTC_Bucket<OTC_String>;

// [03] OTC_Collection

// [04] OTC_Cursor

OSE_MARK_COMPILED OTC_Cursor<int>;
OSE_MARK_COMPILED OTC_Cursor<OTC_String>;

// [05] OTC_Deque

OSE_MARK_COMPILED OTC_Deque<OTC_String>;

// [06] OTC_HashActions

// [07] OTC_Holder

// [08] OTC_ItemCursor

OSE_MARK_COMPILED OTC_ItemCursor<OTC_String,OTC_Bucket<OTC_String> >;
OSE_MARK_COMPILED OTC_ItemCursor<int,OTC_IILink>;

// [09] OTC_Iterator

// [10] OTC_KeyCursor

OSE_MARK_COMPILED OTC_KeyCursor<int,OTC_IILink>;

// [11] OTC_KeyItemCursor

OSE_MARK_COMPILED OTC_KeyItemCursor<int,int,OTC_IILink>;

// [12] OTC_List

OSE_MARK_COMPILED OTC_List<OTC_String>;

// [13] OTC_Map

// [14] OTC_Modifier

// [15] OTC_PairBucket

// [16] OTC_PairCursor

OSE_MARK_COMPILED OTC_PairCursor<int,int>;

// [17] OTC_PairIterator

// [18] OTC_PairModifier

// [19] OTC_Queue

// [20] OTC_RankActions

// [21] OTC_Set

OSE_MARK_COMPILED OTC_Set<OTC_String>;

// [22] OTC_UniqMap

#endif

/* ------------------------------------------------------------------------- */

#endif /* OTC_OTC_H */
