/*
// ============================================================================
//
// = LIBRARY
//     OTC
// 
// = FILENAME
//     ostore/otcstorage.cc
//
// = AUTHOR(S)
//     Graham Dumpleton
// 
// = COPYRIGHT
//     Copyright 1995 DUMPLETON SOFTWARE CONSULTING PTY LIMITED
//
// ============================================================================
*/

#include <OTC/ostore/storage.hh>

#if defined(ENV_OSTORE_DML) || defined(ENV_OSTORE)

/* ------------------------------------------------------------------------- */
OTC_Storage* OTC_Storage::_first = 0;

/* ------------------------------------------------------------------------- */
OTC_Storage::~OTC_Storage()
{
  if (_prev != 0)
    _prev->_next = _next;
  if (_next != 0)
    _next->_prev = _prev;
  if (_first == this)
    _first = _next;
}

/* ------------------------------------------------------------------------- */
OTC_Storage::OTC_Storage()
{
  _prev = 0;

  if (_first == 0)
  {
    _first = this;
    _next = 0;
  }
  else
  {
    _next = _first;
    _first->_prev = this;
    _first = this;
  }
}

/* ------------------------------------------------------------------------- */

#endif
